#include <iostream>
#include <arrayfire.h>

#define DIM 1000 // Number of pixels of the image

using namespace af;

int main()
{
	array offset = seq(DIM*DIM); // holds sequential numbers 0,1,2,...,DIM
	array x_index = (abs)(offset/DIM); // x index of each pixel
	array y_index = (abs)(offset%DIM); // y index of each pixel


	// Calculate the point in complex plane corresponding to the x and y index
	float multiplier = 1.5; // zoom factor
	array realPart =  multiplier *  (DIM/2.0 - x_index) / (DIM/2.0); // used to calculate the real part of pt
	array complexPart =  multiplier *  (DIM/2.0 - y_index) / (DIM/2.0); // used to calculate the imaginary part of pt
	array pt = complex(realPart,complexPart);// DIM*DIM complex points for each pixel of the image

	cuComplex C= {0.285,0.01}; // constant

	// Calculate pt(n+1) = pt(n)*pt(n) + C iteratively
	for(int i=0; i<50; i++){
		pt = pt*pt+ C;
	}

	//holds 0 if point is in Julia Set or 1 if point is outside the Julia Set 
	array result = (((real(pt)*real(pt)) + (imag(pt)*imag(pt))) < 1000);

	array img = constant(0, DIM, DIM, 3); // DIM*DIM 3 channel (RGB) image initialized to zero
	img(span, span, 2) = 255 * result; // set the blue component of the image
	image(img); // renders the image on screen.
	std::cin.get();
	return 0;
}

